"use strict";
/*
 * SonarQube JavaScript Plugin
 * Copyright (C) 2011-2024 SonarSource SA
 * mailto:info AT sonarsource DOT com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the Sonar Source-Available License Version 1, as published by SonarSource SA.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Sonar Source-Available License for more details.
 *
 * You should have received a copy of the Sonar Source-Available License
 * along with this program; if not, see https://sonarsource.com/license/ssal/
 */
// https://sonarsource.github.io/rspec/#/rspec/S3723/javascript
Object.defineProperty(exports, "__esModule", { value: true });
exports.rule = void 0;
const core_js_1 = require("../external/core.js");
const index_js_1 = require("../helpers/index.js");
const meta_js_1 = require("./meta.js");
/**
 * S1537 ('comma-dangle') and S3723 ('enforce-trailing-comma') both depend on the
 * same ESLint implementation, but the plugin doesn't allow rule key duplicates.
 */
exports.rule = {
    ...(0, core_js_1.getESLintCoreRule)('comma-dangle'),
    meta: (0, index_js_1.generateMeta)(meta_js_1.meta, (0, core_js_1.getESLintCoreRule)('comma-dangle').meta),
};
